﻿
using System;
using System.ComponentModel;
using System.Diagnostics;
using System.Drawing;
using System.IO.Pipes;
using System.IO;
using System.Threading.Tasks;
using System.Windows.Forms;
using Wisej.Web;
using System.Threading;

namespace PaintEventFire
{
    public partial class Page1 : Page
    {
        public Page1()
        {
            InitializeComponent();
        }


        #region Tasks_Fails

        // -------- WONT RENDER PICTURE BOX ?-------------

        private async void btnStartTask_Click(object sender, EventArgs e)
        {
            await Task.Run(() => Task.FromResult(this.updateImage()));
        }

        public Task updateImage()
        {
            while (true)
            {
                if (++ImageIndex > imageList1.Images.Count - 1)
                    ImageIndex = 0;

                Image image = imageList1.Images[ImageIndex].Image;

                pictureBox1.Invoke((MethodInvoker)(() =>
                {
                    //if you Break point or click on window and it renders... WeirD?
                    pictureBox1.Image = image;
                    pictureBox1.Invalidate();
                }));

                Thread.Sleep(750);
            }
        }
        #endregion

        #region Timer_Ok
        private void btnStartTimerUpdate_Click(object sender, EventArgs e)
        {
            tmrUpdatePic.Enabled = true;
        }


        int ImageIndex = 0;
        private void tmrUpdatePic_Tick(object sender, EventArgs e)
        {
            if (++ImageIndex > imageList1.Images.Count - 1)
                ImageIndex = 0;
            pictureBox1.Image = imageList1.Images[ImageIndex].Image;
        }
        #endregion

        #region BGWorker
        // -------- BG Worker:  -------------

        void UseBackgroundWorker()
        {
            while (true)
            {
                //Kick off 
                if(!backgroundWorker1.IsBusy)
                    backgroundWorker1.RunWorkerAsync();

                while (backgroundWorker1.IsBusy)
                {
                    // Updating image into pic box
                }
                
            }

        }

        private void btnStartWorkerUpdate_Click(object sender, EventArgs e)
        {
            // Stop other threads.
            tmrUpdatePic.Enabled = false;
            
            
            UseBackgroundWorker();

        }

        private void backgroundWorker1_DoWork(object sender, System.ComponentModel.DoWorkEventArgs e)
        {
            if (++ImageIndex > imageList1.Images.Count - 1)
                ImageIndex = 0;
            e.Result = imageList1.Images[ImageIndex].Image;
        }

        private void backgroundWorker1_RunWorkerCompleted(object sender, RunWorkerCompletedEventArgs e)
        {
            // Check if the background worker completed successfully and the result is an image.
            if (e.Error == null && e.Result is Image image)
            {
                // Set the loaded image to the PictureBox control.
                pictureBox1.Image = image;
                //pictureBox1.Invalidate();
                //Locks up if on gui thread
                Thread.Sleep(1500);
            }
        }
        #endregion
    }
}
